package agentes;

import jade.core.Agent;
import jade.core.behaviours.CyclicBehaviour;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;

public class Barman extends Agent {
	private static final long serialVersionUID = 7565480541103911523L;
	private DFAgentDescription dfd;

	public void setup() {
		System.out.println("Agente " + getLocalName() + " ha empezado.");
		dfd = new DFAgentDescription();
		dfd.setName(getAID());
		ServiceDescription sd = new ServiceDescription();
		sd.setType("barman");
		sd.setName("barman-service");
		dfd.addServices(sd);
		try {
			DFService.register(this, dfd);
		} catch (FIPAException e) {

			e.printStackTrace();
		}
		System.out.println("Agente " + getLocalName() + " Registrandose en Pginas Amarillas");
		addBehaviour(new WaitForCommunication());
	}

	class WaitForCommunication extends CyclicBehaviour {
		private static final long serialVersionUID = 7277977699198704399L;

		public void action() {
			ACLMessage msg = blockingReceive();
			if (msg != null) {
				if (msg.getPerformative() == ACLMessage.NOT_UNDERSTOOD) {
					System.out.println("Mensaje NOT UNDERSTOOD recibido");
				} else if (msg.getPerformative() == ACLMessage.PROPOSE) {
					ACLMessage reply = msg.createReply();
					System.out.println("Agente " + getLocalName() + "Recibido mensaje QUERY_REF de "
							+ msg.getSender().getLocalName() + " con contenido: " + msg.getContent());
					reply.setPerformative(ACLMessage.ACCEPT_PROPOSAL);
					reply.setContent("TakeFoodAndDrinks");
					send(reply);
					System.out.println("Agente " + getLocalName() + "Envio mensaje CONFIRM a "
							+ reply.getSender().getLocalName() + " con contenido: " + reply.getContent());
				} else if (msg.getPerformative() == ACLMessage.INFORM) {
					if (msg.getContent() == "END")
						myAgent.doDelete();
				} else {
					block();
				}
			}
		}
	}

	protected void takeDown() {
		try {
			Thread.sleep(15000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		try {
			DFService.deregister(this);
		} catch (FIPAException fe) {
			fe.printStackTrace();
		}
		System.out.println("Agente " + getLocalName()
				+ " Eliminando servicios de Paginas Amarillas, Saliendo de la fiesta tras la barra.");
	}

}
