package agentes;

import java.util.Random;
import java.util.concurrent.ThreadLocalRandom;

import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.Behaviour;
import jade.core.behaviours.CyclicBehaviour;
import jade.core.behaviours.OneShotBehaviour;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;

public class Guest extends Agent {
	private static final long serialVersionUID = -6387442226036329317L;
	Agent agent = this;
	Random rand = new Random();
	int Satisfaccion = rand.nextInt(25) + 5;

	String[][] ingerir = new String[][] { { "un pintxo de tortilla", "un talo de chistorra", "un pulpo a la gallega" },
			{ "una cerveza", "un refresco", "un gin-tonic" } };

	int op = 0;

	String[] frasesSaludo = { getLocalName() + ": S,. Que tal los ni,os?", "Si, Que tal el trabajo?",
			"Si, Que tal la novia?" };

	String[] frasesFinSaludo = { getLocalName() + ": Todo bien. Gracias!", "Sin comentarios.", "Como si tuviera..." };

	protected void setup() {
		try {
			Thread.sleep(1000); // Dar algo de tiempo al portero
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		System.out.println("Agente " + getLocalName() + " Listo para entrar a la fiesta, a la espera del portero.");

		DFAgentDescription dfd = new DFAgentDescription();
		dfd.setName(getAID());
		ServiceDescription sd = new ServiceDescription();
		sd.setType("invitado");
		sd.setName("invitado " + getLocalName());
		dfd.addServices(sd);

		try {
			DFService.register(agent, dfd);
		} catch (FIPAException fe) {
			fe.printStackTrace();
		}

		// Wait for Portero
		ACLMessage msg = blockingReceive();

		switch (msg.getContent()) {
		case "Entra":
			try {
				DFService.deregister(agent, dfd);
			} catch (FIPAException fe) {
				fe.printStackTrace();
			}
			// Saludar a todos los que estan dentro de la fiesta
			addBehaviour(new saludarATodos());

			// Volver a entrar en las p,ginas amarillas como en la fiesta
			dfd.setName(getAID());
			sd.setType("EnFiesta");
			sd.setName("En la fiesta " + getLocalName());
			dfd.addServices(sd);
			try {
				DFService.register(agent, dfd);
			} catch (FIPAException fe) {
				fe.printStackTrace();
			}
			break;
		}
	}

	// Comportamiento c,clico en la fiesta
	class enfiesta extends CyclicBehaviour {
		private static final long serialVersionUID = 4055876972351078833L;

		public enfiesta(Agent a) {
			super(a);
		}

		public void action() {
			ACLMessage msg = blockingReceive();

			ACLMessage reply = msg.createReply();
			switch (msg.getContent()) {
			case "Saludo":

				op = rand.nextInt(2);

				System.out.println(frasesSaludo[op]);

				reply.setContent("Saludado");
				send(reply);

				break;

			case "Saludado":

				op = rand.nextInt(2);

				System.out.println(frasesFinSaludo[op]);

				break;

			case "FoodAndDrink":

				// Elegir qu, quiere tomar (aleatorio).
				Random rand = new Random();
				int ForD = rand.nextInt(1);
				int option = rand.nextInt(2);
				String answer = "" + ForD + option;
				// Devolver mensaje con informaci,n del pedido al
				// camarero.

				reply.setContent(answer);
				reply.setPerformative(ACLMessage.INFORM);
				send(reply);

				System.out.println(getLocalName() + ": Si, por favor. Traeme " + ingerir[ForD][option]);

				break;

			default:
				System.out.println(getLocalName() + ": ,Muchas gracias! Me apetec,a mucho...");
				Satisfaccion = Satisfaccion - (int) ThreadLocalRandom.current().nextInt(3, 7);
				break;
			}

			if (Satisfaccion <= 0) {
				addBehaviour(new despedirAHost());
			}
		}
	}

	public class despedirAHost extends OneShotBehaviour {
		private static final long serialVersionUID = -8330491019305949020L;

		@Override
		public void action() {
			ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
			msg.addReceiver(new AID("Host", AID.ISLOCALNAME));
			msg.setContent("adios");
			send(msg);
			System.out.println(
					getLocalName() + ": Has sido un gran anfitron, pero va siendo hora de que me vaya a casa.");
			myAgent.doDelete();
		}

	}

	public class saludarATodos extends OneShotBehaviour {
		private static final long serialVersionUID = -6501798302703115055L;

		public void action() {

			// Saludar al anfitrion.
			DFAgentDescription template = new DFAgentDescription();
			ServiceDescription sd = new ServiceDescription();
			sd.setType("Host");
			template.addServices(sd);
			try {
				DFAgentDescription[] result = DFService.search(myAgent, template);
				AID r = new AID();
				if (result.length >= 1) {
					if (result[0].getName().getLocalName() != getLocalName()) {
						r.setLocalName(result[0].getName().getLocalName());
						ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
						msg.setSender(getAID());
						msg.addReceiver(r);
						msg.setContent("Saludo");
						System.out.println(getLocalName() + ": Ave, anfitrion! Uno que viene a la fiesta te saluda.");
						send(msg);
					}
				}
			} catch (FIPAException fe) {
				fe.printStackTrace();
			}

			template = new DFAgentDescription();
			sd = new ServiceDescription();
			sd.setType("EnFiesta");
			template.addServices(sd);

			try {
				DFAgentDescription[] result = DFService.search(myAgent, template);
				AID Invitado = new AID();
				for (int i = 0; i < result.length; i++) {
					if (result.length >= 1 && result[0].getName().getLocalName() != getLocalName()) {
						Invitado.setLocalName(result[i].getName().getLocalName());
						System.out.println(
								getLocalName() + ": Hola! " + result[i].getName().getLocalName() + " Cuanto tiempo!");

						// Enviar mensaje de saludo.
						ACLMessage msg2 = new ACLMessage(ACLMessage.INFORM);
						msg2.addReceiver(Invitado);
						msg2.setContent("Saludo");
						send(msg2);
					}
				}
			} catch (FIPAException fe) {
				fe.printStackTrace();
			}

			System.out.println("Agente " + getLocalName() + " CyclicBehaviour - Divirtiendome en la fiesta.");
			addBehaviour(new enfiesta(myAgent));
		}

	}

	protected void takeDown() {
		try {
			DFService.deregister(this);
		} catch (FIPAException fe) {
			fe.printStackTrace();
		}
		System.out.println(getLocalName() + " :Abandona la fiesta.");
	}

}
