package agentes;

import java.util.concurrent.ThreadLocalRandom;

import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.CyclicBehaviour;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;

public class Host extends Agent {
	private static final long serialVersionUID = 4184516633806473945L;
	private int saludos, despedidas;
	private String[] frasesSaludo = { getLocalName() + " : Si, Que tal los nios?", " :Si, Que tal el trabajo?",
			" :Si, Que tal la novia?" };
	private int op = 0;

	protected void setup() {
		saludos = 0;
		despedidas = 0;
		DFAgentDescription dfd = new DFAgentDescription();
		dfd.setName(getAID());
		ServiceDescription sd = new ServiceDescription();
		sd.setType("host");
		sd.setName("host-service");
		dfd.addServices(sd);
		try {
			DFService.register(this, dfd);
		} catch (FIPAException e) {

			e.printStackTrace();
		}
		addBehaviour(new CheckForGuest(this));
		addBehaviour(new WaitForResponse(this));

	}

	class WaitForResponse extends CyclicBehaviour {
		private static final long serialVersionUID = -4166090871059350391L;

		public WaitForResponse(Agent a) {
			super(a);
		}

		public void action() {
			ACLMessage msg = receive();

			String contenido = msg.getContent();

			switch (contenido) {
			case "Saludo":
				op = (int) ThreadLocalRandom.current().nextInt(0, 3);
				System.out.println("Agente Host" + frasesSaludo[op]);
				ACLMessage reply = msg.createReply();
				reply.setContent("Saludado");
				send(reply);
				saludos++;
				break;
			case "adios":
				System.out.println("Agente " + getLocalName() + ": Un placer haberte tenido en mi fiesta.");
				despedidas++;
				break;
			}
		}
	}

	class CheckForGuest extends CyclicBehaviour {
		private static final long serialVersionUID = 7277977699198704399L;

		public CheckForGuest(Agent a) {
			super(a);
		}

		public void action() {
			if (saludos == despedidas) {
				AID r = new AID();
				r.setLocalName("Portero");
				ACLMessage msg1 = new ACLMessage(ACLMessage.CANCEL);
				msg1.setSender(getAID());
				msg1.addReceiver(r);
				msg1.setContent("END");
				send(msg1);
				r.setLocalName("Camarero1");
				msg1 = new ACLMessage(ACLMessage.CANCEL);
				msg1.setSender(getAID());
				msg1.addReceiver(r);
				msg1.setContent("END");
				send(msg1);
				r.setLocalName("Camarero2");
				msg1 = new ACLMessage(ACLMessage.CANCEL);
				msg1.setSender(getAID());
				msg1.addReceiver(r);
				msg1.setContent("END");
				send(msg1);
				r.setLocalName("Barman");
				msg1 = new ACLMessage(ACLMessage.CANCEL);
				msg1.setSender(getAID());
				msg1.addReceiver(r);
				msg1.setContent("END");
				send(msg1);
				myAgent.doDelete();
			}
		}
	}

	protected void takedown() {
		System.out.println("Agente " + getLocalName() + " - TERMINA LA FIESTA.");
	}

}
