package agentes;

import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.CyclicBehaviour;
import jade.core.behaviours.OneShotBehaviour;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;

public class Portero extends Agent {
	private static final long serialVersionUID = -8314382371370398481L;

	protected void setup() {
		System.out.println("Agente " + getLocalName() + " Listo para trabajar.");
		addBehaviour(new Invite(this));

	}

	class Invite extends CyclicBehaviour {
		private static final long serialVersionUID = 7277977865198704399L;

		public Invite(Agent a) {
			super(a);
		}

		public void action() {
			System.out.println("Mirando en la lista de invitados");
			DFAgentDescription template = new DFAgentDescription();
			ServiceDescription sd = new ServiceDescription();
			sd.setType("invitado");
			template.addServices(sd);

			DFAgentDescription[] result;
			try {
				result = DFService.search(myAgent, template);

				AID Invitado = new AID();
				while (result.length == 0) {
					result = DFService.search(myAgent, template);
				}
				for (int i = 0; i < result.length; ++i) {
					Invitado.setLocalName(result[i].getName().getLocalName());
					System.out.println(
							getLocalName() + ": Hola, " + result[i].getName().getLocalName() + ", puedes pasar.");

					// Enviar mensaje de saludo.
					ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
					msg.setSender(getAID());
					msg.addReceiver(Invitado);
					msg.setContent("Entra");
					send(msg);
					Thread.sleep(1500);
				}
			} catch (FIPAException | InterruptedException e) {
				e.printStackTrace();
			}
		}
	}

	class WaitForResponse extends OneShotBehaviour {
		private static final long serialVersionUID = 7277977699198704399L;

		public WaitForResponse(Agent a) {
			super(a);
		}

		public void action() {
			ACLMessage msg = blockingReceive();
			if (msg != null) {
				if (msg.getPerformative() == ACLMessage.CANCEL) {
					if (msg.getContent() == "END")
						myAgent.doDelete();
				} else {
					block();
				}
			}
		}
	}

	protected void takedown() {
		try {
			Thread.sleep(3000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		System.out.println("Agente " + getLocalName() + " Terminado su trabajo. Se va a casa.");
	}

}
